#include <bits/stdc++.h>
using namespace std;

long long t,n,m,min1=1e9,min2=1e9;
long long a[10001],b[10001],br[10001];

int main (){
cin >>t;
while(t--){
    cin >>n >> m;

    int prvitest[10001],drugitest[10001];

    for(int i=0;i<=10001;i++){
            prvitest[i]=0;
            drugitest[i]=1;
    }

    for(int i=1;i<=n;i++){
        cin >>a[i];


    }

    for(int i =1;i<=n;i++){
        if(a[i]<min1){
        min1=a[i];
        }
        if(a[i]<min2 and a[i]>min1){
        min2=a[i];
        }

    }

    for(int i=1;i<=m;i++){
        cin >> b[i];
    }


for(int i=0;i<=10001;i++){
    br[i]=min1+(min2-min1)*i;
}

for(int i=0;i<=10001;i++){
    for(int j=1;j<=n;j++){
    if(br[i]==a[j]){
        prvitest[j]=1;
    }
}
}

for(int i=0;i<=10001;i++){
    for(int j=1;j<=m;j++){
    if(br[i]==b[j]){
        drugitest[j]=0;
    }
}
}
int prvi=1,drugi=1;

for(int i=1;i<=n;i++){
    if(prvitest[i]==0){
        prvi=0;
    }
}

for(int i=1;i<=n;i++){
    if(drugitest[i]==0){
        drugi=0;
    }
}
//cout << prvi << "      "<< drugi<< endl;
if(prvi+drugi==2){
    cout << 1 << endl;
}
else {
    cout << 0 << endl;
}
prvi=1;
drugi=1;
min1=1e9;
min2=1e9;

}

return 0;
}